var targetE;
var mapType = 100;
var geojson;
var citygeojson;
var riverjson;
var earthquakes;
var airgeojson = new L.markerClusterGroup();
var bigearthquakes;
var maxVal = 0;
var minVal = 0;
var year = 6;
var air1 = 0;
var slider = document.getElementById("myRange");
var slidertext = document.getElementById("yearid");
var legend = L.control({position: 'bottomright'});
var sliderYear = [1960,1970,1980,1990,2000,2010,2016];
var bounds = new L.LatLngBounds(new L.LatLng(-180, -180), new L.LatLng(180, 180));
var labels = ["Population (Mill)"];
var label =  ["Population (Mill)"];
var countryLink = "Country";
var wikilink=1;
var mapPage = window.location.href;
var airIcon = L.icon({
    iconUrl: 'plane.png',
    iconSize:     [19, 19], // size of the icon
    iconAnchor:   [10, 10] // point of the icon which will correspond to marker's location
});

var today = new Date();

// Selected day to show on the map
var day = new Date(today.getTime()-(24*60*60*1000));

function dayParameter() {
    return day.toISOString().split('T')[0];
};

// Update the current slider value (each time you drag the slider handle)
$("#div-slider").change(function() {
	year = parseInt($("#myRange").val());
	slidertext.innerHTML = sliderYear[year];
	changeMap(0);
});

var map = L.map('map',{
	minZoom: 2,
	center: bounds.getCenter(),
	maxBounds: bounds,
	maxBoundsViscosity: 0.75}
).setView([30, 0], 2);


var x = document.getElementById("slider");
x.style.display = "none";

var layer = L.tileLayer('http://{s}.tile.osm.org/{z}/{x}/{y}.png', {
	attribution: '&copy; <a href="http://osm.org/copyright">OSM</a>'
	}).addTo(map);
	
	// control that shows state info on hover
var info = L.control();

info.onAdd = function (map) {
	this._div = L.DomUtil.create('div', 'info');
	this.update();
	return this._div;
};

info.update = function (props, cityYes) {
	var textInfo = ""
	if(cityYes==1){
		switch(mapType){
			case 0:
				try{
					this._div.innerHTML = '<h4>Population</h4>' +  (props ?
					'<b>' + props.name + '<br/>2016: </b>' + (props.pop2016).toLocaleString('en-US')
					+ '<b><br/>2010: </b>' + (props.pop2010).toLocaleString('en-US')
					+ '<b><br/>2000: </b>' + (props.pop2000).toLocaleString('en-US')
					+ '<b><br/>1990: </b>' + (props.pop1990).toLocaleString('en-US')
					+ '<b><br/>1980: </b>' + (props.pop1980).toLocaleString('en-US')
					+ '<b><br/>1970: </b>' + (props.pop1970).toLocaleString('en-US')
					+ '<b><br/>1960: </b>' + (props.pop1960).toLocaleString('en-US')
					: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Population</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 1:
				try{
					this._div.innerHTML = '<h4>Birth Rate (/100,000)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.BirthRateP.toFixed(2)
					: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Birth Rate (/100,000)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 2:
				try{
					this._div.innerHTML = '<h4>Death Rate (/100,000)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.DeathRateP.toFixed(2)
					: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Death Rate (/100,000)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 3:
				try{
					this._div.innerHTML = '<h4>Life Expectancy (yrs)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.AvgLifeExp.toFixed(2)
					: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Life Expectancy (yrs)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 4:
				try{
					this._div.innerHTML = '<h4>Female Life Expect (yrs)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.FemaleLife.toFixed(2)
					: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Female Life Expect (yrs)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 5:
				try{
					this._div.innerHTML = '<h4>Male Life Expect (yrs)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.MaleLifeEx.toFixed(2)
					: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Male Life Expect (yrs)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 6:
				this._div.innerHTML = '<h4>Religion</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + "Christianity: " + props.christ2010 + "%<br/>Islam: " + props.islam2010 +
				"%<br/>Hinduism: " + props.hind2010 + "%<br/>Budhism: " + props.bud2010 + "%<br/>Judaism: " + props.jew2010 + "%<br/> Folk: " +
				props.folk2010 + "%<br/>Other: " + props.other2010 + "%<br/>No Religion: " + props.un2010 +"%"
				: 'Click on a state');
				break;
			case 7:
				this._div.innerHTML = '<h4>Religion</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + "Christianity: " + props.christ2010 + "%<br/>Islam: " + props.islam2010 +
				"%<br/>Hinduism: " + props.hind2010 + "%<br/>Budhism: " + props.bud2010 + "%<br/>Judaism: " + props.jew2010 + "%<br/> Folk: " +
				props.folk2010 + "%<br/>Other: " + props.other2010 + "%<br/>No Religion: " + props.un2010 +"%"
				: 'Click on a state');
				break;
			case 8:
				this._div.innerHTML = '<h4>Religion</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + "Christianity: " + props.christ2010 + "%<br/>Islam: " + props.islam2010 +
				"%<br/>Hinduism: " + props.hind2010 + "%<br/>Budhism: " + props.bud2010 + "%<br/>Judaism: " + props.jew2010 + "%<br/> Folk: " +
				props.folk2010 + "%<br/>Other: " + props.other2010 + "%<br/>No Religion: " + props.un2010 +"%"
				: 'Click on a state');
				break;
			case 9:
				this._div.innerHTML = '<h4>Religion</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + "Christianity: " + props.christ2010 + "%<br/>Islam: " + props.islam2010 +
				"%<br/>Hinduism: " + props.hind2010 + "%<br/>Budhism: " + props.bud2010 + "%<br/>Judaism: " + props.jew2010 + "%<br/> Folk: " +
				props.folk2010 + "%<br/>Other: " + props.other2010 + "%<br/>No Religion: " + props.un2010 +"%"
				: 'Click on a state');
				break;
			case 10:
				this._div.innerHTML = '<h4>Religion</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + "Christianity: " + props.christ2010 + "%<br/>Islam: " + props.islam2010 +
				"%<br/>Hinduism: " + props.hind2010 + "%<br/>Budhism: " + props.bud2010 + "%<br/>Judaism: " + props.jew2010 + "%<br/> Folk: " +
				props.folk2010 + "%<br/>Other: " + props.other2010 + "%<br/>No Religion: " + props.un2010 +"%"
				: 'Click on a state');
				break;
			case 11:
				this._div.innerHTML = '<h4>Religion</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + "Christianity: " + props.christ2010 + "%<br/>Islam: " + props.islam2010 +
				"%<br/>Hinduism: " + props.hind2010 + "%<br/>Budhism: " + props.bud2010 + "%<br/>Judaism: " + props.jew2010 + "%<br/> Folk: " +
				props.folk2010 + "%<br/>Other: " + props.other2010 + "%<br/>No Religion: " + props.un2010 +"%"
				: 'Click on a state');
				break;
			case 12:
				this._div.innerHTML = '<h4>Religion</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + "Christianity: " + props.christ2010 + "%<br/>Islam: " + props.islam2010 +
				"%<br/>Hinduism: " + props.hind2010 + "%<br/>Budhism: " + props.bud2010 + "%<br/>Judaism: " + props.jew2010 + "%<br/> Folk: " +
				props.folk2010 + "%<br/>Other: " + props.other2010 + "%<br/>No Religion: " + props.un2010 +"%"
				: 'Click on a state');
				break;
			case 13:
				this._div.innerHTML = '<h4>Religion</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + "Christianity: " + props.christ2010 + "%<br/>Islam: " + props.islam2010 +
				"%<br/>Hinduism: " + props.hind2010 + "%<br/>Budhism: " + props.bud2010 + "%<br/>Judaism: " + props.jew2010 + "%<br/> Folk: " +
				props.folk2010 + "%<br/>Other: " + props.other2010 + "%<br/>No Religion: " + props.un2010 +"%"
				: 'Click on a state');
				break;
			case 14:
				try{
					this._div.innerHTML = '<h4>GDP (Bil$)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + (props.GDPDollars/1000000000).toLocaleString('en-US',{minimumFractionDigits: 2,  maximumFractionDigits: 2})
					: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>GDP (Bil$)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 15:
				try{
					this._div.innerHTML = '<h4>Working Population <br>(% Adult Pop)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.WorkingPop.toFixed(2)
					: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Working Population <br>(% Adult Pop)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 16:
				try{
					this._div.innerHTML = '<h4>Urban Population (%)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.UrbanPopPe.toFixed(2)
					: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Urban Population (%)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 17:
				try{
					this._div.innerHTML = '<h4>Military Expenditure (% GDP)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.MilitaryEx.toFixed(2)
					: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Military Expenditure (% GDP)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 18:
				try{
					this._div.innerHTML = '<h4>Internet Access (%)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.InternetPe.toFixed(2)
					: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Internet Access (%)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 19:
				try{
					this._div.innerHTML = '<h4>Access to Improved <br>Water (%)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.ImpWaterSo.toFixed(2)
					: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Access to Improved <br>Water (%)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 20:
			try{
				this._div.innerHTML = '<h4>Adults with Degrees (%)</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + props.DegreePerc.toFixed(2)
				: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Adults with Degrees (%)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 21:
			try{
				this._div.innerHTML = '<h4>Adults with Secondary <br>Education (%)</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + props.SecondaryP.toFixed(2)
				: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Adults with Secondary <br>Education (%)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 22:
			try{
				this._div.innerHTML = '<h4>Fossil Fuel Usage <br>(% of Total Energy)</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + props.FossilFuel.toFixed(2)
				: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Fossil Fuel Usage <br>(% of Total Energy)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 23:
			try{
				this._div.innerHTML = '<h4>Renewable Energy Usage <br>(% of Total Energy)</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + props.Renewable.toFixed(2)
				: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Renewable Energy Usage <br>(% of Total Energy)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 24:
			try{
				this._div.innerHTML = '<h4>GHG Emissions(Mt)</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + (props.GHGemmisio/1000).toLocaleString('en-US',{minimumFractionDigits: 2,  maximumFractionDigits: 2})
				: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>GHG Emissions(Mt)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 25:
			try{
				this._div.innerHTML = '<h4>Forested Area (%)</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + props.ForestArea.toFixed(2)
				: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Forested Area (%)</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 26:
			try{
				this._div.innerHTML = '<h4>Mammals Under Threat</h4>' +  (props ?
				'<b>' + props.name + '</b><br />' + props.MammalsThr
				: 'Click on a state');
				}catch(e){
					this._div.innerHTML = '<h4>Mammals Under Threat</h4>' +  (props ?
					'<b>' + props.name + '</b><br/>No Data'
					: 'Click on a state');
				}
				break;
			case 27:
				try{
					this._div.innerHTML = '<h4>Fertility Rate <br>(/Woman)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.FertilityR
					: 'Click on a state');
					}catch(e){
						this._div.innerHTML = '<h4>Fertility Rate <br>(/Woman)</h4>' +  (props ?
						'<b>' + props.name + '</b><br/>No Data'
						: 'Click on a state');
					}
				break;
			case 28:
				try{
					this._div.innerHTML = '<h4>Diabetes (%)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.DiabetesPe
					: 'Click on a state');
					}catch(e){
						this._div.innerHTML = '<h4>Diabetes (%)</h4>' +  (props ?
						'<b>' + props.name + '</b><br/>No Data'
						: 'Click on a state');
					}
				break;
			case 29:
				try{
					this._div.innerHTML = '<h4>Suicide rate <br>(/100,000)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.SuicidePer
					: 'Click on a state');
					}catch(e){
						this._div.innerHTML = '<h4>Suicide rate <br>(/100,000)</h4>' +  (props ?
						'<b>' + props.name + '</b><br/>No Data'
						: 'Click on a state');
					}
				break;
			case 30:
				try{
					this._div.innerHTML = '<h4>Health Expenditure <br>(% GDP)</h4>' +  (props ?
					'<b>' + props.name + '</b><br />' + props.HealthExpP.toFixed(2)
					: 'Click on a state');
					}catch(e){
						this._div.innerHTML = '<h4>Health Expenditure <br>(% GDP)</h4>' +  (props ?
						'<b>' + props.name + '</b><br/>No Data'
						: 'Click on a state');
					}
				break;
			case 100:
				try{
					this._div.innerHTML = '';
					}catch(e){
						this._div.innerHTML = '';
					}
				break;
			
		}
	}else if(cityYes==0){
			try{
				this._div.innerHTML = '<h4>City</h4>' +  (props ?
				'<b>' + props.NAMEASCII + '</b><br/>' + props.SOV0NAME +
				'<br/> <b>Pop:</b> '+ props.POP_MAX.toLocaleString('en-US')
				: 'Click on a state');
			}catch(e){
				this._div.innerHTML = '<h4>City</h4>' +  (props ?
				'<b>' + props.NAMEASCII + '</b><br/>No Data'
				: 'Click on a state');
			}
	}else if(cityYes==2){
			try{
				this._div.innerHTML = '<h4>Airport</h4>' +  (props ?
				'<b>' + props.name
				: 'Click on a state');
			}catch(e){
			}
	}else if(cityYes==3){
			try{
				this._div.innerHTML = ""+(props ?
				'<b>Location: </b>' +  props.place +'<br/><b>Magnitude: </b>' + props.mag +
				'<br/><b>Depth: </b>' + props.dmin + 'km<br/><b>Date: </b>' +
				(new Date(props.time).toUTCString())
				: 'Click on a state');
			}catch(e){
			}
	}else if(cityYes==4){
			try{
				this._div.innerHTML = '<h4>River</h4>' +  (props ?
				'<b>' + props.name_en
				: 'Click on a state');
			}catch(e){

			}
	}
};

info.addTo(map);

// get color depending on population density value
function getColor(d) {
	var max = 0;
	var min = 1000000000000000000;
	
	switch(mapType){
		case 0:		
			max= 1378665000;	
			min = 0;
			break;	
		case 1:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.BirthRateP>max){
					max = countries.features[i].properties.BirthRateP;
				}else if(countries.features[i].properties.BirthRateP<min&&countries.features[i].properties.BirthRateP){
					min = countries.features[i].properties.BirthRateP;
				}
			}
			break;
		case 2:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.DeathRateP>max){
					max = countries.features[i].properties.DeathRateP;
				}else if(countries.features[i].properties.DeathRateP<min&&countries.features[i].properties.DeathRateP){
					min = countries.features[i].properties.DeathRateP;
				}
			}
			break;
		case 3:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.AvgLifeExp>max){
					max = countries.features[i].properties.AvgLifeExp;
				}else if(countries.features[i].properties.AvgLifeExp<min&&countries.features[i].properties.AvgLifeExp){
					min = countries.features[i].properties.AvgLifeExp;
				}
			}
			break;
		case 4:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.AvgLifeExp>max){
					max = countries.features[i].properties.AvgLifeExp;
				}else if(countries.features[i].properties.AvgLifeExp<min&&countries.features[i].properties.AvgLifeExp){
					min = countries.features[i].properties.AvgLifeExp;
				}
			}
			break;
		case 5:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.AvgLifeExp>max){
					max = countries.features[i].properties.AvgLifeExp;
				}else if(countries.features[i].properties.AvgLifeExp<min&&countries.features[i].properties.AvgLifeExp){
					min = countries.features[i].properties.AvgLifeExp;
				}
			}
			break;
		case 6:
			for(var i = 0; i<countries.features.length; i++){
				if(parseInt(countries.features[i].properties.bud2010)>max){
					max = parseInt(countries.features[i].properties.bud2010);
				}
			}
			min = 0;
			break;
		case 7:
			for(var i = 0; i<countries.features.length; i++){
				if(parseInt(countries.features[i].properties.christ2010)>max){
					max = parseInt(countries.features[i].properties.christ2010);
				}
			}
			min = 0;
			break;
		case 8:
			for(var i = 0; i<countries.features.length; i++){
				if(parseInt(countries.features[i].properties.folk2010)>max){
					max = parseInt(countries.features[i].properties.folk2010);
				}
			}
			min = 0;
			break;
		case 9:
			for(var i = 0; i<countries.features.length; i++){
				if(parseInt(countries.features[i].properties.hind2010)>max){
					max = parseInt(countries.features[i].properties.hind2010);
				}
			}
			min = 0;
			break;
		case 10:
			for(var i = 0; i<countries.features.length; i++){
				if(parseInt(countries.features[i].properties.jew2010)>max){
					max = parseInt(countries.features[i].properties.jew2010);
				}
			}
			min = 0;
			break;
		case 11:
			for(var i = 0; i<countries.features.length; i++){
				if(parseInt(countries.features[i].properties.islam2010)>max){
					max = parseInt(countries.features[i].properties.islam2010);
				}
			}
			min = 0;
			break;
		case 12:
			for(var i = 0; i<countries.features.length; i++){
				if(parseInt(countries.features[i].properties.other2010)>max){
					max = parseInt(countries.features[i].properties.other2010);
				}
			}
			min = 0;
			break;
		case 13:
			for(var i = 0; i<countries.features.length; i++){
				if(parseInt(countries.features[i].properties.un2010)>max){
					max = parseInt(countries.features[i].properties.un2010);
				}
			}
			min = 0;
			break;
		case 14:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.GDPDollars>max){
					max = countries.features[i].properties.GDPDollars;
				}else if(countries.features[i].properties.GDPDollars<min&&countries.features[i].properties.GDPDollars){
					min = countries.features[i].properties.GDPDollars;
				}
			}
			break;
		case 15:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.WorkingPop<min&&countries.features[i].properties.WorkingPop){
					min = countries.features[i].properties.WorkingPop;
				}
				max=100;
			}
			break;
		case 16:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.UrbanPopPe>max){
					max = countries.features[i].properties.UrbanPopPe;
				}else if(countries.features[i].properties.UrbanPopPe<min&&countries.features[i].properties.UrbanPopPe){
					min = countries.features[i].properties.UrbanPopPe;
				}
			}
			break;
		case 17:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.MilitaryEx>max){
					max = countries.features[i].properties.MilitaryEx;
				}else if(countries.features[i].properties.MilitaryEx<min&&countries.features[i].properties.MilitaryEx){
					min = countries.features[i].properties.MilitaryEx;
				}
			}
			break;
		case 18:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.InternetPe>max){
					max = countries.features[i].properties.InternetPe;
				}else if(countries.features[i].properties.InternetPe<min&&countries.features[i].properties.InternetPe){
					min = countries.features[i].properties.InternetPe;
				}
			}
			break;
		case 19:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.ImpWaterSo>max){
					max = countries.features[i].properties.ImpWaterSo;
				}else if(countries.features[i].properties.ImpWaterSo<min&&countries.features[i].properties.ImpWaterSo){
					min = countries.features[i].properties.ImpWaterSo;
				}
			}
			break;
		case 20:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.DegreePerc>max){
					max = countries.features[i].properties.DegreePerc;
				}else if(countries.features[i].properties.DegreePerc<min&&countries.features[i].properties.DegreePerc){
					min = countries.features[i].properties.DegreePerc;
				}
			}
			break;
		case 21:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.SecondaryP>max){
					max = countries.features[i].properties.SecondaryP;
				}else if(countries.features[i].properties.SecondaryP<min&&countries.features[i].properties.SecondaryP){
					min = countries.features[i].properties.SecondaryP;
				}
			}
			break;
		case 22:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.FossilFuel>max){
					max = countries.features[i].properties.FossilFuel;
				}else if(countries.features[i].properties.FossilFuel<min&&countries.features[i].properties.FossilFuel){
					min = countries.features[i].properties.FossilFuel;
				}
			}
			break;
		case 23:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.Renewable>max){
					max = countries.features[i].properties.Renewable;
				}else if(countries.features[i].properties.Renewable<min&&countries.features[i].properties.Renewable){
					min = countries.features[i].properties.Renewable;
				}
			}
			break;
		case 24:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.GHGemmisio>max){
					max = countries.features[i].properties.GHGemmisio;
				}else if(countries.features[i].properties.GHGemmisio<min&&countries.features[i].properties.GHGemmisio){
					min = countries.features[i].properties.GHGemmisio;
				}
			}
			break;
		case 25:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.ForestArea>max){
					max = countries.features[i].properties.ForestArea;
				}else if(countries.features[i].properties.ForestArea<min&&countries.features[i].properties.ForestArea){
					min = countries.features[i].properties.ForestArea;
				}
			}
			break;
		case 26:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.MammalsThr>max){
					max = countries.features[i].properties.MammalsThr;
				}else if(countries.features[i].properties.MammalsThr<min&&countries.features[i].properties.MammalsThr){
					min = countries.features[i].properties.MammalsThr;
				}
			}
			break;
		case 27:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.FertilityR>max){
					max = countries.features[i].properties.FertilityR;
				}else if(countries.features[i].properties.FertilityR<min&&countries.features[i].properties.FertilityR){
					min = countries.features[i].properties.FertilityR;
				}
			}
			break;
		case 28:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.DiabetesPe>max){
					max = countries.features[i].properties.DiabetesPe;
				}else if(countries.features[i].properties.DiabetesPe<min&&countries.features[i].properties.DiabetesPe){
					min = countries.features[i].properties.DiabetesPe;
				}
			}
			break;
		case 29:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.SuicidePer>max){
					max = countries.features[i].properties.SuicidePer;
				}else if(countries.features[i].properties.SuicidePer<min&&countries.features[i].properties.SuicidePer){
					min = countries.features[i].properties.SuicidePer;
				}
			}
			break;
		case 30:
			for(var i = 0; i<countries.features.length; i++){
				if(countries.features[i].properties.HealthExpP>max){
					max = countries.features[i].properties.HealthExpP;
				}else if(countries.features[i].properties.HealthExpP<min&&countries.features[i].properties.HealthExpP){
					min = countries.features[i].properties.HealthExpP;
				}
			}
			break;
	}
	
	maxVal=max;
	minVal=min;
	
	return d > (min+((max-min)*0.9)) ? '#800026' :
			d > (min+((max-min)*0.7))  ? '#BD0026' :
			d > (min+((max-min)*0.5))  ? '#E31A1C' :
			d > (min+((max-min)*0.25))  ? '#FC4E2A' :
			d > (min+((max-min)*0.1))  ? '#FD8D3C' :
			d > (min+((max-min)*0.05))  ? '#FEB24C' :
			d > (min+((max-min)*0.025))  ? '#FED976' :
			d > 0 ?	'#FFEDA0' :
			d == "< 1.0" ? '#FFEDA0' :
				'#D5D4D4';
}

function style(feature) {
	switch(mapType){
		case 0:			
			switch(year){
				case 0:
					return {
						weight: 2,
						opacity: 1,
						color: 'white',
						dashArray: '3',
						fillOpacity: 0.7,
						fillColor: getColor(feature.properties.pop1960)
					};
					break;	
				case 1:
					return {
						weight: 2,
						opacity: 1,
						color: 'white',
						dashArray: '3',
						fillOpacity: 0.7,
						fillColor: getColor(feature.properties.pop1970)
					};	
					break;	
				case 2:
					return {
						weight: 2,
						opacity: 1,
						color: 'white',
						dashArray: '3',
						fillOpacity: 0.7,
						fillColor: getColor(feature.properties.pop1980)
					};	
					break;	
				case 3:
					return {
						weight: 2,
						opacity: 1,
						color: 'white',
						dashArray: '3',
						fillOpacity: 0.7,
						fillColor: getColor(feature.properties.pop1990)
					};	
					break;	
				case 4:
					return {
						weight: 2,
						opacity: 1,
						color: 'white',
						dashArray: '3',
						fillOpacity: 0.7,
						fillColor: getColor(feature.properties.pop2000)
					};	
					break;	
				case 5:
					return {
						weight: 2,
						opacity: 1,
						color: 'white',
						dashArray: '3',
						fillOpacity: 0.7,
						fillColor: getColor(feature.properties.pop2010)
					};	
					break;	
				case 6:
					return {
						weight: 2,
						opacity: 1,
						color: 'white',
						dashArray: '3',
						fillOpacity: 0.7,
						fillColor: getColor(feature.properties.pop2016)
					};	
					break;	
			}
		case 1:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.BirthRateP)
			};	
			break;
		case 2:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.DeathRateP)
			};	
			break;
		case 3:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.AvgLifeExp)
			};	
			break;
		case 4:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.FemaleLife)
			};	
			break;
		case 5:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.MaleLifeEx)
			};	
			break;
		case 6:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.bud2010)
			};	
			break;
		case 7:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.christ2010)
			};	
			break;
		case 8:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.folk2010)
			};	
			break;
		case 9:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.hind2010)
			};	
			break;
		case 10:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.jew2010)
			};	
			break;
		case 11:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.islam2010)
			};	
			break;
		case 12:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.other2010)
			};	
			break;
		case 13:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.un2010)
			};	
			break;
		case 14:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.GDPDollars)
			};	
			break;
		case 15:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.WorkingPop)
			};	
			break;
		case 16:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.UrbanPopPe)
			};	
			break;
		case 17:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.MilitaryEx)
			};	
			break;
		case 18:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.InternetPe)
			};	
			break;
		case 19:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.ImpWaterSo)
			};	
			break;
		case 20:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.DegreePerc)
			};	
			break;
		case 21:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.SecondaryP)
			};	
			break;
		case 22:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.FossilFuel)
			};	
			break;
		case 23:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.Renewable)
			};	
			break;
		case 24:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.GHGemmisio)
			};	
			break;
		case 25:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.ForestArea)
			};	
			break;
		case 26:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.MammalsThr)
			};	
			break;
		case 27:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.FertilityR)
			};	
			break;
		case 28:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.DiabetesPe)
			};	
			break;
		case 29:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.SuicidePer)
			};	
			break;
		case 30:
			return {
				weight: 2,
				opacity: 1,
				color: 'white',
				dashArray: '3',
				fillOpacity: 0.7,
				fillColor: getColor(feature.properties.HealthExpP)
			};	
			break;
	}
}

function highlightFeature(e) {
	
	var layer = e.target;
	targetE=layer;
	layer.setStyle({
		weight: 3,
		color: '#666',
		dashArray: '',
		fillOpacity: 0.7
	});

	info.update(layer.feature.properties,1);
	
	if (!L.Browser.ie && !L.Browser.opera && !L.Browser.edge) {
        layer.bringToFront();
		try{
		earthquakes.bringToFront();
		}catch(e){
			
		}
		try{
		bigearthquakes.bringToFront();
		}catch(e){
			
		}
		try{
		airgeojson.bringToFront();
		}catch(e){
			
		}
		try{
		citygeojson.bringToFront();
		}catch(e){
			
		}
		try{
		riverjson.bringToFront();
		}catch(e){
			
		}
    }
	
	countryLink=layer.feature.properties.popdata_Co;
}

function resetHighlight(e) {
	geojson.resetStyle(e.target);
	info.update();
}

function onEachFeature(feature, layer) {
	layer.on({
		mouseover: highlightFeature,
		mouseout: resetHighlight
	});
}

/*
geojson = L.geoJson(countries, {
	style: style,
	onEachFeature: onEachFeature
}).addTo(map);*/
	
addLegend();

map.attributionControl.addAttribution('Data from &copy; <a href="http://www.worldbank.org/">World Bank: </a><a href="https://datacatalog.worldbank.org/public-licenses#cc-by">World Development Indicators</a> Earthquake data: <a href="https://usgs.gov">USGS</a>');

function changeMap(clicked_id){
	if(geojson!=null){
		map.removeLayer(geojson);
	}
    x.style.display = "none";
	mapType=clicked_id;
	if(mapType!=100){
		
		switch(clicked_id){
			case 0:
				mapType = 0;
				labels = ["Population (Mill)"];
				x.style.display = "block";
				break;
			case 1:
				mapType = 1;
				labels = ["Birth Rate (/10,0000)"];
				break;
			case 2:
				mapType = 2;
				labels = ["Death Rate (/100,000)"];
				break;
			case 3:
				mapType = 3;
				labels = ["Life Expectancy (yrs)"];
				break;
			case 4:
				mapType = 4;
				labels = ["Female Life Expect (yrs)"];
				break;
			case 5:
				mapType = 5;
				labels = ["Male Life Expect (yrs)"];
				break;
			case 6:
				mapType = 6;
				labels = ["Budhism (%)"];
				break;
			case 7:
				mapType = 7;
				labels = ["Christianity (%)"];
				break;
			case 8:
				mapType = 8;
				labels = ["Folk (%)"];
				break;
			case 9:
				mapType = 9;
				labels = ["Hinduism (%)"];
				break;
			case 10:
				mapType = 10;
				labels = ["Judaism (%)"];
				break;
			case 11:
				mapType = 11;
				labels = ["Islam (%)"];
				break;
			case 12:
				mapType = 12;
				labels = ["Other (%)"];
				break;
			case 13:
				mapType = 13;
				labels = ["No Religion (%)"];
				break;
			case 14:
				mapType = 14;
				labels = ["GDP (Billion $)"];
				break;
			case 15:
				mapType = 15;
				labels = ["Age Dependency Ratio<br>(Working Pop/Pop Age 15-64)"];
				break;
			case 16:
				mapType = 16;
				labels = ["Urban Pop (%)"];
				break;
			case 17:
				mapType = 17;
				labels = ["Military Spend (% GDP)"];
				break;
			case 18:
				mapType = 18;
				labels = ["Internet Access (%)"];
				break;
			case 19:
				mapType = 19;
				labels = ["Improved Water (%)"];
				break;
			case 20:
				mapType = 20;
				labels = ["Adults with Degrees (%)"];
				break;
			case 21:
				mapType = 21;
				labels = ["Secondary Education (%)"];
				break;
			case 22:
				mapType = 22;
				labels = ["Fossil Fuel Usage <br>(% energy production)"];
				break;
			case 23:
				mapType = 23;
				labels = ["Renewable Energy <br>(% energy production)"];
				break;
			case 24:
				mapType = 24;
				labels = ["GHG Emissions (Mt)"];
				break;
			case 25:
				mapType = 25;
				labels = ["Forested Area (%)"];
				break;
			case 26:
				mapType = 26;
				labels = ["Mammals Under Threat"];
				break;
			case 27:
				mapType = 27;
				labels = ["Fertility Rate <br>(/Woman)"];
				break;
			case 28:
				mapType = 28;
				labels = ["Diabetes (%)"];
				break;
			case 29:
				mapType = 29;
				labels = ["Suicide rate <br>(/100,000)"];
				break;
			case 30:
				mapType = 30;
				labels = ["Health Expenditure <br>(% GDP)"];
				break;
		}
		label = JSON.parse(JSON.stringify(labels));
		geojson = L.geoJson(countries, {
			style: style,
			onEachFeature: onEachFeature
		}).addTo(map);
		geojson.bringToBack();
		addLegend();
		topfive();
	};
	if(targetE){
		info.update(targetE.feature.properties,1);
	}
}

function addLegend(){
	if(mapType!=100){
		legend.onAdd = function (map) { 
			
			var maxValText = maxVal;
			var minValText = minVal;
			
			if(mapType==0){
				maxValText=maxVal/1000000;
				minValText=minVal/1000000;
			}else if(mapType==14){
				maxValText=maxVal/1000000000;
				minValText=minVal/1000000000;
			}else if(mapType==24){
				maxValText=maxVal/1000;
				minValText=minVal/1000;
			};
			
			var div = L.DomUtil.create('div', 'info legend'),
				grades = [minValText.toFixed(1), (0.025*(maxValText-minValText)+minValText).toFixed(1), (0.05*(maxValText-minValText)+minValText).toFixed(1), (0.1*(maxValText-minValText)+minValText).toFixed(1), (0.25*(maxValText-minValText)+minValText).toFixed(1), (0.5*(maxValText-minValText)+minValText).toFixed(1), (0.7*(maxValText-minValText)+minValText).toFixed(1), (0.9*(maxValText-minValText)+minValText).toFixed(1)],
				from, to;
			
			var constantPop = 1;
			if(mapType==0){
				constantPop = 1000000;
			}else if(mapType==14){
				constantPop = 1000000000;
			}else if(mapType==24){
				constantPop = 1000;
			};
			
			var colorVal;
			for (var i = 0; i < grades.length; i++) {
				from = grades[i];
				to = grades[i + 1];
				if(i<(grades.length-1)){
					colorVal=((constantPop*from) + (constantPop*to))/2;
				}else{
					colorVal = (constantPop*from+1);
				}
				labels.push(
					'<i style="background:' + getColor(colorVal) + '"></i> ' +
					from + (to ? '&ndash;' + to : '+'));
			}

			div.innerHTML = labels.join('<br>');
			return div;
		};
		legend.addTo(map);
	}
};

function returnCountry(){
	return countryLink;
}


function highlightFeatureCity(e) {
	
	var layer = e.target;
	targetE=layer;
	layer.setStyle({
		weight: 3,
		dashArray: '',
		fillOpacity: 0.7
	});

	info.update(layer.feature.properties,0);
	
	countryLink=layer.feature.properties.NAMEASCII;
}

function resetHighlightCity(e) {
    var layer = e.target;
    layer.setStyle({
		weight: 2,
		opacity: 1,
		color: 'white',
		dashArray: '3',
		fillOpacity: 0.7,
		fillColor: 	"#008080"});
}

function onEachFeatureCity(feature, layer) {
	layer.on({
		mouseover: highlightFeatureCity,
		mouseout: resetHighlightCity
	});
}

function stylecities(feature) {
	var radiuscity = feature.properties.POP_MAX/750000;
	if(radiuscity<6)radiuscity=6;
	return {
		radius: radiuscity,
		weight: 2,
		opacity: 1,
		color: 'white',
		dashArray: '3',
		fillOpacity: 0.7,
		fillColor: 	"#008080"
	};
};

function removeCities(){
	try{
		map.removeLayer(citygeojson);
	}catch(e){
	}
};

function addCities(){
	citygeojson=L.geoJson(cities, {
		  pointToLayer: function (features, coordinates) {
			  return L.circleMarker(coordinates, stylecities(features));
		  },
		onEachFeature: onEachFeatureCity
	}).addTo(map);	
};

function highlightFeatureAir(e) {
	var layer = e.target;
	targetE=layer;
	info.update(layer.feature.properties,2);
	countryLink=layer.feature.properties.name+" Airport";
};

function onEachFeatureAir(feature, layer) {
	layer.on({
		mouseover: highlightFeatureAir,
	});
};

function removeAir(){
	try{
		map.removeLayer(airgeojson);
	}catch(e){
	}
};

function addAir(){
	if(air1==0){
		airgeojson.addLayer(L.geoJson(airports,{
			pointToLayer: function(features, coordinates){
				return L.marker(coordinates, {icon: airIcon});
			},
			onEachFeature: onEachFeatureAir
		}));
		air1=1;
	}
	map.addLayer(airgeojson);
};

function highlightFeatureEarth(e) {
	
	var layer = e.target;
	targetE=layer;
	layer.setStyle({
		weight: 3,
		dashArray: '',
		fillOpacity: 0.7
	});
	info.update(layer.feature.properties,3);
};

function resetHighlightEarth(e) {
    var layer = e.target;
    layer.setStyle({
		weight: 2,
		opacity: 1,
		color: 'white',
		dashArray: '3',
		fillOpacity: 0.7,
		fillColor: 	"#eeee00"});
};


function onEachFeatureEarth(feature, layer) {
	layer.on({
		mouseover: highlightFeatureEarth,
		mouseout: resetHighlightEarth,
	});
};

function styleearth(feature) {
	var radius = feature.properties.mag*feature.properties.mag/2.5;
	return {
		radius: radius,
		weight: 2,
		opacity: 1,
		color: 'white',
		dashArray: '3',
		fillOpacity: 0.7,
		fillColor: 	"#eeee00"
	};
};

function removeEarth(){
		map.removeLayer(earthquakes);
};

function addEarth(){
	var today = new Date();
	var dd = today.getDate();
	var ee = today.getDate();
	var mm = today.getMonth()+1; //January is 0!
	var yyyy = today.getFullYear();

	if(dd<10) {dd = '0'+dd} 
	if(mm<10) {mm = '0'+mm} 
	var date = yyyy+"-"+mm+"-"+dd;
	
	mm = mm - 1;
	if(ee>28) {ee = 28} 
	if(ee<10) {ee = '0'+ee} 
	var yestdate = yyyy+"-"+mm+"-"+ee;

	$.get('https://earthquake.usgs.gov/fdsnws/event/1/query?format=geojson&starttime='+yestdate+'&endtime='+date+'&minmagnitude=5',function(data,status) {
		var earth = JSON.parse(data);
		earthquakes = L.geoJson(earth, {
			pointToLayer: function (features, coordinates) {
				return L.circleMarker(coordinates, styleearth(features));
			},
			onEachFeature: onEachFeatureEarth
		}).addTo(map);
	},'html');
};

function resetHighlightBigEarth(e) {
    var layer = e.target;
    layer.setStyle({
		weight: 2,
		opacity: 1,
		color: 'white',
		dashArray: '3',
		fillOpacity: 0.7,
		fillColor: 	"#2988bc"});
};


function onEachFeatureBigEarth(feature, layer) {
	layer.on({
		mouseover: highlightFeatureEarth,
		mouseout: resetHighlightBigEarth,
	});
};

function stylebigearth(feature) {
	var radius = feature.properties.mag*feature.properties.mag/3.5;
	return {
		radius: radius,
		weight: 2,
		opacity: 1,
		color: 'white',
		dashArray: '3',
		fillOpacity: 0.7,
		fillColor: 	"#2988bc"
	};
};

function addBigEarth(){
	var today = new Date();
	var dd = today.getDate();
	var mm = today.getMonth()+1;//January is 0!
	var yyyy = today.getFullYear();

	if(dd<10) {dd = '0'+dd} 
	if(mm<10) {mm = '0'+mm} 
	var date = yyyy+"-"+mm+"-"+dd;
	
	$.get('https://earthquake.usgs.gov/fdsnws/event/1/query?format=geojson&starttime=0000-00-00&endtime='+date+'&minmagnitude=8.5',function(data,status) {
		var earth = JSON.parse(data);
		bigearthquakes = L.geoJson(earth, {
			pointToLayer: function (features, coordinates) {
				return L.circleMarker(coordinates, styleearth(features));
			},
			onEachFeature: onEachFeatureEarth
		}).addTo(map);
	},'html');
};

function removeBigEarth(){
	map.removeLayer(bigearthquakes);
};

function highlightFeatureRiver(e) {
	var layer = e.target;
	targetE=layer;
	info.update(layer.feature.properties,4);
	countryLink=layer.feature.properties.name_en+"_River";
};

function onEachFeatureRiver(feature, layer) {
	layer.on({
		mouseover: highlightFeatureRiver,
	});
};

function styleRiver(feature) {
	return {
		weight: 20,
		opacity: 1,
		color: 'white',
		dashArray: '3',
		fillOpacity: 0.7,
		fillColor: 	"#008080"
	};
};

function removeRiver(){
	try{
		map.removeLayer(riverjson);
	}catch(e){
	}
};

function addRiver(){
	riverjson = L.geoJson(rivers, {
		  pointToLayer: function (features, coordinates) {
			  return L.polyline(coordinates, styleRiver(features));
		  },
		onEachFeature: onEachFeatureRiver
	}).addTo(map);	
};

function removeLayer(itemid){
	if(itemid!=1){
		try{
			map.removeLayer(citygeojson);
		}catch(e){
		}
	}
	if(itemid!=2){
		try{
			map.removeLayer(airgeojson);
		}catch(e){
		}
	}
	if(itemid!=3){
		try{
			map.removeLayer(earthquakes);
		}catch(e){
		}
	}
	if(itemid!=4){
		try{
			map.removeLayer(bigearthquakes);
		}catch(e){
		}
	}
	if(itemid!=5){
		try{
			map.removeLayer(riverjson);
		}catch(e){
		}
	}
}

function topfive(){
	var topfiveobj= new Array();
	if(mapType!=100){
		switch(mapType){
			case 0:
				switch(year){
					case 0:			
						for(var i = 0; i<countries.features.length; i++){
							var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.pop1960/1000000};
							topfiveobj.push(obj);
						}
						break;
					case 1:				
						for(var i = 0; i<countries.features.length; i++){
							var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.pop1970/1000000};
							topfiveobj.push(obj);
						}
						break;
					case 2:				
						for(var i = 0; i<countries.features.length; i++){
							var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.pop1980/1000000};
							topfiveobj.push(obj);
						}
						break;
					case 3:				
						for(var i = 0; i<countries.features.length; i++){
							var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.pop1990/1000000};
							topfiveobj.push(obj);
						}
						break;
					case 4:				
						for(var i = 0; i<countries.features.length; i++){
							var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.pop2000/1000000};
							topfiveobj.push(obj);
						}
						break;
					case 5:				
						for(var i = 0; i<countries.features.length; i++){
							var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.pop2010/1000000};
							topfiveobj.push(obj);
						}
						break;
					case 6:					
						for(var i = 0; i<countries.features.length; i++){
							var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.pop2016/1000000};
							topfiveobj.push(obj);
						}
						break;
				}
				break;
			case 1:
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.BirthRateP};
					topfiveobj.push(obj);
				}
				break;
			case 2:
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.DeathRateP};
					topfiveobj.push(obj);
				}
				break;
			case 3:
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.AvgLifeExp};
					topfiveobj.push(obj);
				}
				break;
			case 4:
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.FemaleLife};
					topfiveobj.push(obj);
				}
				break;
			case 5: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.MaleLifeEx};
					topfiveobj.push(obj);
				}
				break;
			case 6:
				mapType = 6;
				labels = ["Budhism (%)"];
				break;
			case 7:
				mapType = 7;
				labels = ["Christianity (%)"];
				break;
			case 8:
				mapType = 8;
				labels = ["Folk (%)"];
				break;
			case 9:
				mapType = 9;
				labels = ["Hinduism (%)"];
				break;
			case 10:
				mapType = 10;
				labels = ["Judaism (%)"];
				break;
			case 11:
				mapType = 11;
				labels = ["Islam (%)"];
				break;
			case 12:
				mapType = 12;
				labels = ["Other (%)"];
				break;
			case 13:
				mapType = 13;
				labels = ["No Religion (%)"];
				break;
			case 14: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.GDPDollars/1000000000};
					topfiveobj.push(obj);
				}
				break;
			case 15: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.WorkingPop};
					topfiveobj.push(obj);
				}
				break;
			case 16: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.UrbanPopPe};
					topfiveobj.push(obj);
				}
				break;
			case 17: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.MilitaryEx};
					topfiveobj.push(obj);
				}
				break;
			case 18: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.InternetPe};
					topfiveobj.push(obj);
				}
				break;
			case 19: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.ImpWaterSo};
					topfiveobj.push(obj);
				}
				break;
			case 20: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.DegreePerc};
					topfiveobj.push(obj);
				}
				break;
			case 21: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.SecondaryP};
					topfiveobj.push(obj);
				}
				break;
			case 22:
				mapType = 22;
				labels = ["Fossil Fuel Usage <br>(% energy production)"];
				break;
			case 23:
				mapType = 23;
				labels = ["Renewable Energy <br>(% energy production)"];
				break;
			case 24:
				mapType = 24;
				labels = ["GHG Emissions (Mt)"];
				break;
			case 25: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.ForestArea};
					topfiveobj.push(obj);
				}
				break;
			case 26: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.MammalsThr};
					topfiveobj.push(obj);
				}
				break;
			case 27: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.FertilityR};
					topfiveobj.push(obj);
				}
				break;
			case 28: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.DiabetesPe};
					topfiveobj.push(obj);
				}
				break;
			case 29: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.SuicidePer};
					topfiveobj.push(obj);
				}
				break;
			case 30: 
				for(var i = 0; i<countries.features.length; i++){
					var obj = {name:countries.features[i].properties.name, value:countries.features[i].properties.HealthExpP};
					topfiveobj.push(obj);
				}
				break;
		}
		var tempobj = {name:"temp", value:100000000000};
		
		var objone=topfiveobj[0];
		var objtwo=topfiveobj[0];
		var objthr=topfiveobj[0];
		var objfou=topfiveobj[0];
		var objfiv=topfiveobj[0];
		var objbone=tempobj;
		var objbtwo=tempobj;
		var objbthr=tempobj;
		var objbfou=tempobj;
		var objbfiv=tempobj;
		for(var i = 0; i<topfiveobj.length; i++){
			if(topfiveobj[i].value==null){
				
			}else if(topfiveobj[i].value>objone.value){
				objfiv=objfou;
				objfou=objthr;
				objthr=objtwo;
				objtwo=objone;
				objone=topfiveobj[i];
			}else if(topfiveobj[i].value>objtwo.value){
				objfiv=objfou;
				objfou=objthr;
				objthr=objtwo;
				objtwo=topfiveobj[i];
			}else if(topfiveobj[i].value>objthr.value){
				objfiv=objfou;
				objfou=objthr;
				objthr=topfiveobj[i];
			}else if(topfiveobj[i].value>objfou.value){
				objfiv=objfou;
				objfou=topfiveobj[i];
			}else if(topfiveobj[i].value>objfiv.value){
				objfiv=topfiveobj[i];
			}else if(topfiveobj[i].value<objbone.value){
				objbfiv=objbfou;
				objbfou=objbthr;
				objbthr=objbtwo;
				objbtwo=objbone;
				objbone=topfiveobj[i];
			}else if(topfiveobj[i].value<objbtwo.value){
				objbfiv=objbfou;
				objbfou=objbthr;
				objbthr=objbtwo;
				objbtwo=topfiveobj[i];
			}else if(topfiveobj[i].value<objbthr.value){
				objbfiv=objbfou;
				objbfou=objbthr;
				objbthr=topfiveobj[i];
			}else if(topfiveobj[i].value<objbfou.value){
				objbfiv=objbfou;
				objbfou=topfiveobj[i];
			}else if(topfiveobj[i].value<objbfiv.value){
				objbfiv=topfiveobj[i];
			}
		}
		document.getElementById("myPopup").innerHTML="<b>"+label+"</b><br><table id=\""+"customers"+"\"><tr><th><b>Highest</b></th></tr><tr><th>"+
		objone.name+"</th><th>"+(objone.value).toLocaleString('en-US', {maximumFractionDigits: 2})+
		"</th></tr><tr><th>"+objtwo.name+"</th><th>"+(objtwo.value).toLocaleString('en-US', {maximumFractionDigits: 2})+
		"</th></tr><tr><th>"+objthr.name+"</th><th>"+(objthr.value).toLocaleString('en-US', {maximumFractionDigits: 2})+
		"</th></tr><tr><th>"+objfou.name+"</th><th>"+(objfou.value).toLocaleString('en-US', {maximumFractionDigits: 2})+
		"</th></tr><tr><th>"+objfiv.name+"</th><th>"+(objfiv.value).toLocaleString('en-US', {maximumFractionDigits: 2})+"</th></tr><tr><th><b>Lowest</b></th></tr><tr><th>"+
		objbone.name+"</th><th>"+(objbone.value).toLocaleString('en-US', {maximumFractionDigits: 2})+
		"</th></tr><tr><th>"+objbtwo.name+"</th><th>"+(objbtwo.value).toLocaleString('en-US', {maximumFractionDigits: 2})+
		"</th></tr><tr><th>"+objbthr.name+"</th><th>"+(objbthr.value).toLocaleString('en-US', {maximumFractionDigits: 2})+
		"</th></tr><tr><th>"+objbfou.name+"</th><th>"+(objbfou.value).toLocaleString('en-US', {maximumFractionDigits: 2})+
		"</th></tr><tr><th>"+objbfiv.name+"</th><th>"+(objbfiv.value).toLocaleString('en-US', {maximumFractionDigits: 2})+"</th></tr>"
	}
}

function clearMap(){
		map.removeLayer(geojson);
		mapType=100;
		map.removeControl(legend);
	
}

function showlist() {
	topfive();
    var popup = document.getElementById("myPopup");
    popup.classList.toggle("show");
}

function hidelist(){
    var popup = document.getElementById("myPopup");
    popup.classList.toggle("hide");
}

function normalMap(){
	map.removeLayer(layer);
	layer = L.tileLayer('http://{s}.tile.osm.org/{z}/{x}/{y}.png', {
	attribution: '&copy; <a href="http://osm.org/copyright">OSM</a>'
	}).addTo(map);
	map.attributionControl.addAttribution('Data from &copy; <a href="http://www.worldbank.org/">World Bank: </a><a href="https://datacatalog.worldbank.org/public-licenses#cc-by">World Development Indicators</a> Earthquake data: <a href="https://usgs.gov">USGS</a>');
}

function topoMap(){
	map.removeLayer(layer);
	layer = L.tileLayer('https://{s}.tile.opentopomap.org/{z}/{x}/{y}.png', {
	maxZoom: 17,
	attribution: 'Map data: &copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>, <a href="http://viewfinderpanoramas.org">SRTM</a> | Map style: &copy; <a href="https://opentopomap.org">OpenTopoMap</a> (<a href="https://creativecommons.org/licenses/by-sa/3.0/">CC-BY-SA</a>)'
	}).addTo(map);
	map.attributionControl.addAttribution('Data from &copy; <a href="http://www.worldbank.org/">World Bank: </a><a href="https://datacatalog.worldbank.org/public-licenses#cc-by">World Development Indicators</a> Earthquake data: <a href="https://usgs.gov">USGS</a>');
}

function seaTempMap(){
	var template = 'https://gibs-{s}.earthdata.nasa.gov/wmts/epsg3857/best/' + '{layer}/default/{time}/{tileMatrixSet}/{z}/{y}/{x}.png';
	layer = L.tileLayer(template, {
      layer: 'GHRSST_L4_MUR_Sea_Surface_Temperature',
      tileMatrixSet: 'EPSG3857_1km',
      time: dayParameter(),
      noWrap: true,
      continuousWorld: true,
	  attribution: '&copy; <a href="https://wiki.earthdata.nasa.gov/display/GIBS">' +
        'NASA EOSDIS GIBS</a>&nbsp;&nbsp;&nbsp;' +
        '<a href="https://github.com/nasa-gibs/web-examples/blob/master/examples/leaflet/time.js">' +
        'View Source' +
        '</a>'
	}).addTo(map);
	map.attributionControl.addAttribution('Data from &copy; <a href="http://www.worldbank.org/">World Bank: </a><a href="https://datacatalog.worldbank.org/public-licenses#cc-by">World Development Indicators</a> Earthquake data: <a href="https://usgs.gov">USGS</a>');
}

function landscapeMap(){
	map.removeLayer(layer);
	layer = L.tileLayer('https://tile.thunderforest.com/landscape/{z}/{x}/{y}.png?apikey=3a1412b2229744888ded08e4d74ed6bc', {
	attribution: '&copy; <a href="http://www.thunderforest.com/">OSM</a>'
	}).addTo(map);
	map.attributionControl.addAttribution('Data from &copy; <a href="http://www.worldbank.org/">World Bank: </a><a href="https://datacatalog.worldbank.org/public-licenses#cc-by">World Development Indicators</a> Earthquake data: <a href="https://usgs.gov">USGS</a>');
}

function outdoorMap(){
	map.removeLayer(layer);
	layer = L.tileLayer('https://tile.thunderforest.com/outdoors/{z}/{x}/{y}.png?apikey=3a1412b2229744888ded08e4d74ed6bc', {
	attribution: '&copy; <a href="http://www.thunderforest.com/">OSM</a>'
	}).addTo(map);
	map.attributionControl.addAttribution('Data from &copy; <a href="http://www.worldbank.org/">World Bank: </a><a href="https://datacatalog.worldbank.org/public-licenses#cc-by">World Development Indicators</a> Earthquake data: <a href="https://usgs.gov">USGS</a>');
}